#include "stdafx.h"
#include <stdio.h>
#include <stdlib.h>
#include <tchar.h>
#include "SHA.h"

CSHA::CSHA()
{
    m_hProvider = NULL;
    m_bError = false;

    CryptAcquireContext(&m_hProvider, NULL, NULL, PROV_DSS, CRYPT_VERIFYCONTEXT);
}

CSHA::~CSHA()
{
    CryptReleaseContext(m_hProvider, 0);
}

TString CSHA::GetSHAString(TString sFile)
{
    m_hCryptHash = NULL;
    m_bError = FALSE;

	// Generate a SHA-1 for a particular file
	HANDLE hFile;
	hFile = CreateFile(sFile.c_str(),GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_FLAG_SEQUENTIAL_SCAN,NULL);
	if (hFile == INVALID_HANDLE_VALUE)
    {
        m_bError = TRUE;
		return _T("                                        ");
    }

	BYTE pbBuffer[65536];
	DWORD dwBytesRead = 0;

    CryptCreateHash(m_hProvider, CALG_SHA1, 0, 0, &m_hCryptHash);

    if (m_hCryptHash == NULL)
    {
        CloseHandle(hFile);
        return _T("                                        ");
    }

	while (ReadFile(hFile,pbBuffer,65536,&dwBytesRead,NULL))
	{
		if (dwBytesRead == 0)
			break;

        CryptHashData(m_hCryptHash, pbBuffer, dwBytesRead, 0);

		if (dwBytesRead != 65536)
			break;
	}

	if (hFile != INVALID_HANDLE_VALUE)
	{
		CloseHandle(hFile);
		hFile = INVALID_HANDLE_VALUE;
	}

    BYTE pbHash[64];
    DWORD dwDataSize = 64;

    CryptGetHashParam(m_hCryptHash, HP_HASHVAL, pbHash, &dwDataSize, 0);

    TCHAR szHex[3];

    TString sHash;

    for(DWORD i = 0; i < dwDataSize; i++)
    {
        _sntprintf_s(szHex, 4, _T("%2.2x"), pbHash[i]);
        sHash.append(szHex);
    }

    CryptDestroyHash(m_hCryptHash);
    return sHash;
}

